<template>
    <main>

        <article v-if="isLoading" id="container-body-ville" class="container mt-3">
            <section id="bodyVille">
                <MessageBox type="simulateur" message="Les données de la ville sont en cours de chargement." />
            </section>
        </article>
        <article v-else-if="isError" id="container-body-ville" class="container mt-3">
            <section id="bodyVille">
                <MessageBox v-if="notexists" type="simulateur" message="La commune n'existe pas ou n'a pas pu être chargée correctement." />
                <MessageBox v-else type="simulateur" message="Une une erreur est survenu durant le chargement  des données. Êtes-vous connectés à internet ?" />

                <div class="container">
                    <div class="row">
                        <RetourRecherche title="Retour à l'accueil" />
                    </div>
                </div>
            </section>
        </article>
        <div v-else>

             <headerVille />

             <ChoiceSecteur v-if="ville_mere.secteurs && secteur == null" @change="updateSecteur" />

            <article v-if="ville_mere.secteurs == null || secteur != null" id="container-body-ville" class="container mt-3">
                <section v-if="ville.Population > 1000" id="bodyVille">
                    <div class="row border no-gutters ">

                        <div v-if="ville.Population > 1000" class="col-md-12" >
                            <ToggleSwitch @change="updateTour" :value='tour' />

                                <div class="nombre-2014">
                                    <div>
                                        <div>
                                            <img src="/images/population2.svg" width="25px" />
                                            <span v-html="$t('generic.nombredesuffrages')"></span>
                                        </div>
                                        <!-- <span v-if="tour == 0"> {{ Number(ville.Exprimes_premier_tour).toLocaleString() }} </span>
                                        <span v-else> {{ Number(ville.Exprimes_deuxieme_tour).toLocaleString() }} </span> -->
                                        <div class="input-container">
                                            <input
                                                v-model="nombresuffrages"
                                                class="input-group-field "
                                                float-label="Nombre de Suffrages exprimés"
                                                numeric-keyboard-toggle
                                                @blur="updateSuffrages"
                                                placeholder="Nombre de Suffrages exprimés"
                                                type="number"
                                                value=""
                                                :max="nombresuffragesmax"
                                                :min="nombresuffragesmin"
                                                :disabled="disabledInputSuffrage"
                                            />

                                            <b-button style="margin-left: 0.5rem" id="popup-suffrages-exprimes" class="btn btn-popup">?</b-button>
                                            <b-popover ref="popover" target="popup-suffrages-exprimes" triggers="focus">
                                                Basé sur la participation aux municipales de 2014 au premier et/ou deuxième tour.<br/>
                                                Source Ministère de l'intérieur. <br/>
                                                Cette valeur est modifiable
                                            </b-popover>
                                        </div>
                                    </div>
                                    <div class="reinit" v-if="nombresuffrages != nombresuffragesdefault" @click="reinitValeurSuffrages">Réinitialiser la valeur des suffrages exprimés avec les données de 2014</div>
                                </div>

                                <hr />

                                <component :is="dynamicComponent" :pourcentageTotal="pourcentageTotal" :nombresuffrages="nombresuffrages" :calculPourcentageTotal="calculPourcentageTotal" :disabledButton="disabledButton" :swap-component="swapComponent"></component>
                        </div>
                    </div>
                </section>
                <div v-else-if="ville.Population == 0" class="row">
                    <MessageBox type="simulateur" message="Ville morte pour la France" />
                </div>
                <div v-else class="row">
                    <MessageBox type="simulateur" icon='images/warning.png' message="Le mode de scrutin pour les communes de moins de 1000 habitants ne permet pas de simuler les résultats de l'électionde votre municipalité. <br/><a href='https://www.vie-publique.fr/fiches/20203-municipales-mode-de-scrutin-communes-de-moins-de-1000-habitants' target='__blank'> En savoir plus sur le scrutin majoritaire plurinominal à deux tours.</a>" />
                </div>

                <div class="container">
                    <div class="row">
                        <RetourVille v-if="ville_mere.secteurs" />
                        <RetourRecherche :title="$t('generic.simuleruneautrecommune')" />
                    </div>
                </div>
            </article>
        </div>
    </main>
</template>


<script>

import headerVille from '@/components/simulateur/HeaderVille.vue'

import BodyListesVille from '@/components/simulateur/parts/BodyListesVille.vue'
import BodyResultatsVille from '@/components/simulateur/parts/BodyResultatsVille.vue'

import RetourRecherche from '@/components/simulateur/interaction/RetourRecherche.vue'
import RetourVille from '@/components/simulateur/interaction/RetourVille.vue'
import ToggleSwitch from '@/components/simulateur/interaction/ToggleSwitch.vue'
import ChoiceSecteur from '@/components/simulateur/interaction/ChoiceSecteur.vue'

import MessageBox from '@/components/simulateur/parts/MessageBox.vue'

import { villeGetters, villeMethode } from '@/store/ville.js';

import axios from 'axios'

export default {
    name: "simulateur",
    data: function () {
      return {
        isError: false,
        isLoading: false,
        dynamicComponent: 'body-liste',
        disabledButton: true,
        pourcentageTotal: 0,
        url: process.env.VUE_APP_HOSTS,
        nombresuffrages: 0,
        nombresuffragesdefault: 0,
        nombresuffragesmax: 0,
        nombresuffragesmin: 1000,
        disabledInputSuffrage: false,
        notexists: false
      }
    },
    computed: {
      ...villeGetters
    },
    watch: {
      '$route.params.insee': function () {
        //
        // insee = 5;
        this.setTour(0);
        this.isLoading = false;
        this.notexists = false;
        this.isError = false;
        this.loadVille();
      }
    },
    components: {
        headerVille,

        ToggleSwitch,
        RetourRecherche,
        RetourVille,

        MessageBox,

        ChoiceSecteur,

        'body-liste': BodyListesVille,
        'body-resultat': BodyResultatsVille
    },
    methods: {
      //Pour initier les données pour le localstorage des listes
      setVille: villeMethode.setVille,
      setTour: villeMethode.setTour,
      setSecteur: villeMethode.setSecteur,
      setSuffrage: villeMethode.setSuffrage,

      swapComponent: function(component, tour = null) {

          this.disabledInputSuffrage = true;
          if(component == 'body-liste'){
              this.disabledInputSuffrage = false;
              this.pourcentageTotal = 0;
          }


          if(tour != null){
              this.setTour(tour);

              let datas = JSON.parse(localStorage.datas);

              if(tour == 1 && (datas[this.ville.Id_ville_insee][1] == undefined || datas[this.ville.Id_ville_insee][1].length == 0)){

                  datas[this.ville.Id_ville_insee][1] = [];

                  Object.keys(datas[this.ville.Id_ville_insee][0]).forEach((key) => {

                      let pourcentage = datas[this.ville.Id_ville_insee][0][key].pourcentage;
                      let nom = datas[this.ville.Id_ville_insee][0][key].nom;

                      if(pourcentage > 5) {

                          let variable = {pourcentage: '', nom: nom};
                          datas[this.ville.Id_ville_insee][1].push(variable);
                      }
                  });

                  localStorage.setItem('datas', JSON.stringify(datas));
              }

              this.dynamicComponent = component;
          }
          else{
              this.dynamicComponent = component;
          }


      },
      updateTour: function(valeur) {

          this.setTour(valeur);
          this.swapComponent('body-liste', null);
          this.updateSuffrageField();

          this.calculPourcentageTotal();

      },
      reinitValeurSuffrages(){
          this.updateSuffrageField();
      },
      updateSuffrageField()
      {
          if(this.tour == 0){
              if(this.ville.Exprimes_premier_tour > 0){
                  this.nombresuffragesdefault = this.nombresuffrages = this.ville.Exprimes_premier_tour;
                  this.nombresuffragesmax = parseInt(this.ville.Nombres_inscrits_listes_electoral);
              }
          }
          else {
              if(this.ville.Exprimes_deuxieme_tour > 0){
                  this.nombresuffragesdefault = this.nombresuffrages = this.ville.Exprimes_deuxieme_tour;
                  this.nombresuffragesmax = parseInt(this.ville.Nombres_inscrits_listes_electoral);
              }
              else if(this.ville.Exprimes_premier_tour > 0){
                  this.nombresuffragesdefault = this.nombresuffrages = this.ville.Exprimes_premier_tour;
                  this.nombresuffragesmax = parseInt(this.ville.Nombres_inscrits_listes_electoral);
              }
          }

          this.setSuffrage(this.nombresuffrages);
      },
      updateSecteur: function(valeur) {

          this.setSecteur(valeur);
          this.setVille(null, valeur);

          this.updateTour(0);
      },
      loadVille: async function(){
          this.swapComponent(null);
          try {

              this.isLoading = true;

              await axios
                  .get(`${this.url}${this.$route.params.insee}`, null)
                  .then(response => {

                      if(response.data.error != undefined){
                          this.notexists = true;
                          this.isError = true;
                      }
                      else {
                          this.setVille(response.data);
                      }

                  });

                  if(!this.notexists){
                      this.updateSuffrageField();
                      this.swapComponent('body-liste');
                  }

                  this.isLoading = false;

          } catch (err) {
              this.isLoading = false;
              this.isError = true;
          }
      },
      calculPourcentageTotal(lines = null) {

          if(lines == null){
              let lStorage = JSON.parse(localStorage.datas);

              lines = [];

              if(lStorage[this.ville.Id_ville_insee] != undefined && lStorage[this.ville.Id_ville_insee][this.tour] != undefined){
                  lines = lStorage[this.ville.Id_ville_insee][this.tour];
              }
              else {
                  lines = null
              }

          }

          if(lines == null){
              return false;
          }

          this.pourcentageTotal = lines.reduce((accumulator, currentValue) => {
              let value = currentValue.pourcentage;
              if(value == null || value == undefined || value == '') {
                  value = 0;
              }
              return accumulator + parseFloat(value);
          }, 0);

          if(this.pourcentageTotal > 100 || (this.tour == 1 && this.pourcentageTotal < 100) && this.nombresuffrages > 0){
              this.disabledButton = true;
          }
          else{
              this.disabledButton = false;
          }

      },
      updateSuffrages(event) {
        const newValue = parseInt(event.target.value)
        let min = event.target.min;
        let max = event.target.max;

        this.$nextTick(()=>{
            if (min >= newValue) {
              this.nombresuffrages = min;
            } else if (max <= newValue) {
              this.nombresuffrages = max;
            }
        })

        this.setSuffrage(this.nombresuffrages);
      }
    },
    created: function () {
        this.setTour(0);
        this.setSecteur(null);
        this.loadVille();

        window.scrollTo(0, 0);
    }

};
</script>
